;---------------------------------------------------------------------
;   Floating Point
;   file : float.inc
;   2000/11/04 (C) Jun Mizutani
;---------------------------------------------------------------------

%ifndef __FLOAT_INC
%define __FLOAT_INC

section .bss
Sign            resb    1       ; 
BCD             rest    1       ;  BCD ɽ(10Х)
ExpSign         resb    1       ; ؿ
Exponent        resd    1       ; ؿ(4Х)
DigitStr        resb    20      ; BCDѴѿ buffer

section .text

;---------------------------------------------------------------------
; FPU ΥåȥåפΥ쥸ưХåեʸ
; ȤƳǼ. ǡ쥸å pop 뤿, ɬפʤ
; call  fld st0  dup Ƥ.
; BCDϥȥ륨ǥǳǼƤ뤳Ȥ
; 쥸¸
; edi ʸѤΥХåեƬɥ쥹ꤷƸƤ (29byteʾ)
;---------------------------------------------------------------------

Float2Ascii:    pusha
                call   Float2BCD            ; ư
                ffree  st0                  ; åȥåפ
                fincstp                     ; pop
                cmp    byte[Sign], 0        ; å
                je     .positive
                mov    al, "-"
                mov    [edi], al
                inc    edi
    .positive
                mov    esi, BCD
                add    esi, 8               ; BCDƬ̵ХȤ򥹥å
                mov    bh, [esi]
                mov    bl, bh
                shr    bh, 4
                or     bh, 0x30
                mov    [edi], bh            ; ʲ1
                inc    edi
                mov    al, "."              ; 
                mov    [edi], al
                inc    edi
                and    bl, 0x0F
                or     bl, 0x30
                mov    [edi], bl            ; 1
                inc    edi
    .next
                dec    esi                  ; BCD1ХȤ
                mov    bh, [esi]
                mov    bl, bh
                shr    bh, 4
                or     bh, 0x30
                mov    [edi], bh
                inc    edi
                and    bl, 0x0F
                or     bl, 0x30
                mov    [edi], bl
                inc    edi
                cmp    esi, BCD
                jne    .next

                ; ؿɽ
                mov    ebx, [Exponent]
                or     ebx, ebx             ; ؿͤå
                je     .exit
                mov    al, "e"
                mov    [edi], al
                inc    edi
                or     ebx, ebx             ; ؿͤå
                jg     .e_positive
                neg    ebx
                mov    al, "-"
                mov    [edi], al
                inc    edi
    .e_positive
                ; ؿͤѴ
                mov    eax, ebx
                mov    ebx, 100000000
                mov    ecx, 9
                mov    esi, 0
    .exp_loop:
                xor    edx, edx             ; edx = 0
                div    ebx                  ; eax = edx:eax / ebx
                push   edx                  ; modulo
                test   eax, eax
                jz     .ps1
                add    al, '0'
                mov    [edi], al
                inc    edi
                inc    esi                  ; 0 ʳοͽи
                jmp    short  .ps2

        .ps1:   test   esi, esi             ;  0 ɽʤ
                jz     .ps2
                add    al, '0'              ; 10/29
                mov    [edi], al
                inc    edi
        .ps2:
                pop    eax                  ; modulo

                push   edi
                xor    edx, edx             ; edx = 0
                xchg   eax, ebx             ;  : save eax
                mov    edi, 10              ; ebx = ebx / 10
                div    edi                  ;  :
                xchg   eax, ebx             ;  : restore eax
                pop    edi
                loop   .exp_loop
        .exit
                xor    eax, eax
                mov    [edi], al
                popa
                ret

;---------------------------------------------------------------------
; FPU ΥåȥåפΥ쥸ư
; Sign, BCD, Exponent ʬ򤷤ƳǼ
; 2ɽ 80bit ư10ɽѴ
; Float2Ascii ƤӽФ
;---------------------------------------------------------------------

Float2BCD:      push    eax
                mov     byte [Sign], 0      ; οͤ
                fldz                        ; 0 ץå
                fcomp   st1                 ; st0  st1 Ӥ pop
                fstsw   ax                  ; ե饰axž
                sahf                        ; ah ե饰쥸ž
                jz      near .zero

                push    ebx
                push    edx
    .notzero                                ; Ǥʤ, 
                jb      .Positive
                fabs                        ; Ͽͤ
                mov     byte [Sign], 1

    .Positive ; 椬
                mov     dword [Exponent], 0 ; ؿ 0 ǽ

              ; ؿȽ
                fld1                        ; 1.0 ץå
                fcomp   st1                 ; (1.0 - n) Ƚ꤬դˤʤ
                fstsw   ax
                sahf
                jbe    .PosExp              ; ʲʤ.NegExp

    ;----------------------------------------------------------
    ; λؿξ
    ;  0  1 δ֤οͤƤ롥
    ; Ŭ10Τ٤軻ƿf 1 < f < 10 Ȥʤ褦ˤ롥
                mov     ebx, TblSize*10     ; ɽľ
                mov     edx, 8192
    .NegExp
                sub     ebx, 10             ; ɽΣ˰ư
                shr     edx, 1
                test    edx, edx            ; ٤0ʤ鼡
                jz      .mul10

                fld     tword [NegTbl + ebx]; 10Τ٤
                fcomp   st1                 ; st0(10^n) - st1
                fstsw   ax                  ; ե饰axž
                sahf                        ; ah ե饰쥸ž
                jbe    .NegExp             ; ַ֤ 11/1

                sub     [Exponent], edx     ; ؿ -= ExpTbl [di]
                fld     tword [PosTbl + ebx]; 10Τ٤軻
                fmulp   st1, st0
                jmp     .NegExp             ; ˷֤

    .mul10
                fld     tword [PosTbl]      ; 10軻
                fmulp   st1, st0
                dec     dword [Exponent]    ; ؿ -= 1
                jmp     .range1_10

    ;----------------------------------------------------------
    ; λؿοͤ򰷤
    ; Ŭ10Τ٤ƿf 1< f <10 Ȥʤ褦ˤ롥
    .PosExp
                mov     ebx, TblSize*10     ; ɽ黲
                mov     edx, 8192
    .PosExp2
                sub     ebx, 10             ; ɽΣ˰ư
                shr     edx, 1
                test    edx, edx
                jz      .range1_10

                fld     tword [PosTbl + ebx]; 10Τ٤
                fcomp   st1                 ; st0(10^n) - st1
                fstsw   ax                  ; ե饰axž
                sahf                        ; ah ե饰쥸ž
                ja      .PosExp2            ; 礭ַ֤

                add     [Exponent], edx
                fld     tword [PosTbl + ebx]; 1 x 2^n
                fdivp   st1, st0            ;  st1/st0
                jmp     .PosExp2            ; ˷֤

    .range1_10
                ; λǿͤ 1 <= x < 10 ϰϤˤʤäƤ,
                ; 10^17 褸(Ĥ17ʬ)BCDѴ
                fld     tword [MaxDigits]
                fmul    st1
                ; 10^18 fbstp ˼Ԥн
                fld     tword [MaxBCD]
                fcomp   st1
                fstsw   ax                  ; ե饰axž
                sahf                        ; ah ե饰쥸ž
                jae    .bcd
                fld     tword [PosTbl]
                fdivp   st1, st0
                inc     dword [Exponent]    ; ؿ += 1
    .bcd
                fbstp   tword [BCD] ; stack topBCD18ǥ10byte˳Ǽ
                                    ; ѴRCǻꤵݤ⡼ɤ
                                    ; BCD ˤ 18BCDȤ֤롥
                pop     edx
                pop     ebx
                pop     eax
                ret

              ; ξ̡ȤƤΥ
    .zero
                xor     eax, eax
                mov     [BCD], eax          ; BCD10ХȤ0
                mov     [BCD + 4], eax
                mov     [BCD + 8], ax
                mov     dword[Exponent], 0
                mov     byte[Sign], ' '
                pop     eax
                ret

;---------------------------------------------------------------------
; edi ꤵ줿ưʸ 80bit  FPU Υåȥå
; ǡ쥸ꤹ롥Ƭʬζ䥿֤ϽƤ.
; ͤ "yyy.xxxx" (y <> 0) ηΤȤ
; "yyy" η夬18ʾξñ˻ؿäƿ̵
; Υɤʸ DigitStr ˵ս˳ǼƤ뤳Ȥ.
; ȥ륨ǥξ礳ͭ
; 10ɽưʸ 2ɽ 80bit ưѴ
; edi ɤ߹ߺѤߤΥХåեμΰ֤֤. ¾Υ쥸¸.
;---------------------------------------------------------------------

Ascii2Float:    push    eax
                push    ebx
                push    edx

                xor     eax, eax
                mov     ebx, DigitStr
     .Clear     mov     [ebx], eax
                add     ebx, 4
                cmp     ebx, DigitStr + 20
                jne     .Clear

                mov     edx, -18            ; BCDѴΤλؿν
                mov     ebx, 18             ; ٤ĤäƤͭ
                mov     byte[Sign], 0
                call    GetChar
                jae     .SkipZero
                cmp     al, "+"             ; ?
                je      .SkipSign
                cmp     al, "-"
                jne     near .ConvErr
                mov     byte[Sign], 1
    .SkipSign:  call    GetChar
                jae     .SkipZero
                cmp     al, "."             ; Ϥޤ?
                je      .FractionPart
                jmp     near .ConvErr
    .SkipZero
                cmp     al, 0               ; Ƭʬ 0 
                jne     .Digits
                call    GetChar
                jb      .DecimalPoint
                jmp     .SkipZero

    .Digits:
                inc     edx                 ; ʾοͷĴ
                test    ebx, ebx            ; ͭĶƤʤ
                jz      .SkipDigit          ; 18ۤϥå
                mov     [DigitStr + ebx], al; ͤ
                dec     ebx
    .SkipDigit
                call    GetChar
                jb      .DecimalPoint
                jmp     .Digits
    .DecimalPoint:
                cmp     al, "."
                jne     .BCDConv

    ;----------------------------------------------------------
    ; ʲην
    ; ʲγƷǤϣ头Ȥ˻ؿ򸺾ɬפ롥
    ; FPU  BCDѴǤϾʲͤϵʤᡥ
    ; 㤨 0.12345 --> 12345e-5 Ȥ롥
    .FractionPart:
                call    GetChar
                jb      .BCDConv
                cmp     ebx, 18             ; Ǥ0ʳο 10/29
                jne     .Fp2                ;                   10/29
                cmp     al, 0               ; .0000xx å
                jne     .Fp2
                dec     edx
                jmp     .FractionPart

    .FractionPart2:
                call    GetChar
                jb      .BCDConv
        .Fp2:   test    ebx, ebx            ; ͭĶ?
                jz      .FractionPart2      ; ĶƤ̵뤹

                mov     [DigitStr + ebx], al; ĶƤʤгǼ
                dec     ebx
                jmp     .FractionPart2

    ;----------------------------------------------------------
    ; DigitStr ѿ BCD Ѵ
    ; ʸοĤβ4ӥåȤBCD1ХȤѴ
    .BCDConv:
                push    eax
                push    edi
                push    esi
                mov     edi, BCD
                add     edi, 8
                mov     esi, DigitStr
                add     esi, 18
    .BCDLoop:   mov     al, [esi]
                dec     esi
                shl     al,4
                or      al, [esi]
                dec     esi
                mov     [edi], al
                dec     edi
                cmp     esi, DigitStr
                ja      .BCDLoop
                fbld    [BCD]               ; BCD ͤ FPU ˥
                pop     esi
                pop     edi
                pop     eax
    ;----------------------------------------------------------
    ; ؿν
    .ExponentPart
                cmp     al, "e"             ; e ޤ E Υå
                je      .Exponent
                cmp     al, "E"
                jne     .SetExponent

    ;----------------------------------------------------------
    ; ؿͤɤ BCDѤĴ줿ؿͤ˲ä
    .Exponent
                mov     byte[ExpSign], 0    ; λؿ
                xor     ebx, ebx
                xor     eax, eax
                call    GetChar             ; E θʸ
                jae     .ExpNum             ; λؿ
                cmp     al, "+"
                je      .EatExpSign
                cmp     al, "-"
                jne     near .ConvErr       ; +,-,Digit Ǥʤ
                mov     byte[ExpSign], 1    ; ؿ
    .EatExpSign:
                call    GetChar             ; θʸ
                jb      near .ConvErr       ; θ˿ɬ
    .ExpNum:
                imul    ebx, 10             ; ؿοͲ
                add     ebx, eax
                call    GetChar
                jae     .ExpNum

                cmp     byte[ExpSign], 0    ; ؿ餫
                je      .PosExp
                neg     ebx                 ; ˤ
    .PosExp:
                add     edx, ebx            ; BCDѤλؿ˲ä
    .SetExponent
                cmp     edx, 4930           ; ؿϰϳå
                jg      .ConvErr
                cmp     edx, -4930
                jl      .ConvErr
                mov     ebx, TblSize*10     ; ɽľ
                test    edx, edx            ; ؿ餫ɤ
                js      .NegativeExp

    ;----------------------------------------------------------
    ; ؿ
                shl     edx, 19             ; ꡼Ȥ
    .ExpLoop1:
                test    edx, edx            ; ؿ0ʤ齪λ
                jz      .Done
                sub     ebx, 10
                shl     edx, 1
                jnc     .ExpLoop1
                fld     tword[PosTbl + ebx]
                fmulp   st1, st0
                jmp     .ExpLoop1

    ;----------------------------------------------------------
    ; ؿ
    .NegativeExp:
                neg     edx                 ; ͤ
                shl     edx, 19             ; ꡼Ȥ
    .ExpLoop2:  test    edx, edx            ; 0 ʤ齪λ
                jz      .Done
                sub     ebx, 10
                shl     edx, 1
                jnc     .ExpLoop2
                fld     tword[PosTbl + ebx]
                fdivp   st1, st0
                jmp     .ExpLoop2

    .Done:
                cmp     byte[Sign], 0
                je      .Exit
                fchs
    .Exit
                pop     edx
                pop     ebx
                pop     eax
                clc
                ret

    .ConvErr:   pop     edx
                pop     ebx
                pop     eax
                stc
                ret

;---------------------------------------------------------------------
; 210ѴѤ
;---------------------------------------------------------------------
MaxBCD:         dt  9.99999999999999999e17
MaxDigits       dt  1.0e+17
NegTbl          dt  1.0e-1
                dt  1.0e-2
                dt  1.0e-4
                dt  1.0e-8
                dt  1.0e-16
                dt  1.0e-32
                dt  1.0e-64
                dt  1.0e-128
                dt  1.0e-256
                dt  1.0e-512
                dt  1.0e-1024
                dt  1.0e-2048
                dt  1.0e-4096

PosTbl:         dt  10.0
                dt  1.0e+2
                dt  1.0e+4
                dt  1.0e+8
                dt  1.0e+16
                dt  1.0e+32
                dt  1.0e+64
                dt  1.0e+128
                dt  1.0e+256
                dt  1.0e+512
                dt  1.0e+1024
                dt  1.0e+2048
                dt  1.0e+4096

TblSize         equ  ($-PosTbl)/10

;---------------------------------------------------------------------
; AL ʸɤΥå
; ʤѴ AL ֤. ʤ饭꡼å
;---------------------------------------------------------------------
IsDigit:
                cmp     al, "0"             ; 
                jb      NotDigit
                cmp     al, "9"
                ja      NotDigit
                sub     al, "0"             ; Ѵ
                ctc
                ret
    NotDigit:
                stc
                ret

;---------------------------------------------------------------------
; Хåեμο AL ˼
; ʤѴ AL ֤. ʤ饭꡼å
;---------------------------------------------------------------------
GetChar:        mov     al, [edi]
                inc     edi                 ; ʸ AL ˼
                call    IsDigit
                ret

%endif
