;-------------------------------------------------------------------------
;  file : printfb.inc
;  2000/01/26
;  Copyright (C) 2001  Jun Mizutani <mizutani.jun@nifty.ne.jp>
;-------------------------------------------------------------------------

section .text

;-------------------------------------------------------------------------
; t[obt@̏\
;-------------------------------------------------------------------------
PrintFBScreenInfo:
                mov     eax, sc00
                call    OutAsciiZ
                mov     eax, sc01
                call    OutAsciiZ
                mov     eax, [scinfo_data.xres            ]
                call    FBPrintInfo
                mov     eax, sc02
                call    OutAsciiZ
                mov     eax, [scinfo_data.yres            ]
                call    FBPrintInfo
                mov     eax, sc03
                call    OutAsciiZ
                mov     eax, [scinfo_data.xres_virtual    ]
                call    FBPrintInfo
                mov     eax, sc04
                call    OutAsciiZ
                mov     eax, [scinfo_data.yres_virtual    ]
                call    FBPrintInfo
                mov     eax, sc05
                call    OutAsciiZ
                mov     eax, [scinfo_data.xoffset         ]
                call    FBPrintInfo
                mov     eax, sc06
                call    OutAsciiZ
                mov     eax, [scinfo_data.yoffset         ]
                call    FBPrintInfo
                mov     eax, sc07
                call    OutAsciiZ
                mov     eax, [scinfo_data.bits_per_pixel  ]
                call    FBPrintInfo
                mov     eax, sc08
                call    OutAsciiZ
                mov     eax, [scinfo_data.grayscale       ]
                call    FBPrintInfo
                mov     eax, sc09
                call    OutAsciiZ
                mov     eax, [scinfo_data.red_offset      ]
                call    FBPrintInfo
                mov     eax, sc10
                call    OutAsciiZ
                mov     eax, [scinfo_data.red_length      ]
                call    FBPrintInfo
                mov     eax, sc11
                call    OutAsciiZ
                mov     eax, [scinfo_data.red_msb_right   ]
                call    FBPrintInfo
                mov     eax, sc12
                call    OutAsciiZ
                mov     eax, [scinfo_data.green_offset    ]
                call    FBPrintInfo
                mov     eax, sc13
                call    OutAsciiZ
                mov     eax, [scinfo_data.green_length    ]
                call    FBPrintInfo
                mov     eax, sc14
                call    OutAsciiZ
                mov     eax, [scinfo_data.green_msb_right ]
                call    FBPrintInfo
                mov     eax, sc15
                call    OutAsciiZ
                mov     eax, [scinfo_data.blue_offset     ]
                call    FBPrintInfo
                mov     eax, sc16
                call    OutAsciiZ
                mov     eax, [scinfo_data.blue_length     ]
                call    FBPrintInfo
                mov     eax, sc17
                call    OutAsciiZ
                mov     eax, [scinfo_data.blue_msb_right  ]
                call    FBPrintInfo
                mov     eax, sc18
                call    OutAsciiZ
                mov     eax, [scinfo_data.transp_offset   ]
                call    FBPrintInfo
                mov     eax, sc19
                call    OutAsciiZ
                mov     eax, [scinfo_data.transp_length   ]
                call    FBPrintInfo
                mov     eax, sc20
                call    OutAsciiZ
                mov     eax, [scinfo_data.transp_msb_right]
                call    FBPrintInfo
                mov     eax, sc21
                call    OutAsciiZ
                mov     eax, [scinfo_data.nonstd          ]
                call    FBPrintInfo
                mov     eax, sc22
                call    OutAsciiZ
                mov     eax, [scinfo_data.activate        ]
                call    FBPrintInfo
                mov     eax, sc23
                call    OutAsciiZ
                mov     eax, [scinfo_data.height          ]
                call    FBPrintInfo
                mov     eax, sc24
                call    OutAsciiZ
                mov     eax, [scinfo_data.width           ]
                call    FBPrintInfo
                mov     eax, sc25
                call    OutAsciiZ
                mov     eax, [scinfo_data.accel_flags     ]
                call    FBPrintInfo
                mov     eax, sc26
                call    OutAsciiZ
                mov     eax, [scinfo_data.pixclock        ]
                call    FBPrintInfo
                mov     eax, sc27
                call    OutAsciiZ
                mov     eax, [scinfo_data.left_margin     ]
                call    FBPrintInfo
                mov     eax, sc28
                call    OutAsciiZ
                mov     eax, [scinfo_data.right_margin    ]
                call    FBPrintInfo
                mov     eax, sc29
                call    OutAsciiZ
                mov     eax, [scinfo_data.upper_margin    ]
                call    FBPrintInfo
                mov     eax, sc30
                call    OutAsciiZ
                mov     eax, [scinfo_data.lower_margin    ]
                call    FBPrintInfo
                mov     eax, sc31
                call    OutAsciiZ
                mov     eax, [scinfo_data.hsync_len       ]
                call    FBPrintInfo
                mov     eax, sc32
                call    OutAsciiZ
                mov     eax, [scinfo_data.vsync_len       ]
                call    FBPrintInfo
                mov     eax, sc33
                call    OutAsciiZ
                mov     eax, [scinfo_data.sync            ]
                call    FBPrintInfo
                mov     eax, sc34
                call    OutAsciiZ
                mov     eax, [scinfo_data.vmode           ]
                call    FBPrintInfo
                call    NewLine
                ret

PrintFBFixScreenInfo:
                mov     eax, fsc00
                call    OutAsciiZ
                mov     eax, fsc01
                call    OutAsciiZ
                mov     eax, fscinfo.id
                call    OutAsciiZ
                call    NewLine
                mov     eax, fsc02
                call    OutAsciiZ
                mov     eax, [fscinfo.smem_start ]
                call    PrintHex8
                call    NewLine
                mov     eax, fsc03
                call    OutAsciiZ
                mov     eax, [fscinfo.smem_len   ]
                call    FBPrintInfo
                mov     eax, fsc04
                call    OutAsciiZ
                mov     eax, [fscinfo.type       ]
                call    FBPrintInfo
                mov     eax, fsc05
                call    OutAsciiZ
                mov     eax, [fscinfo.type_aux   ]
                call    FBPrintInfo
                mov     eax, fsc06
                call    OutAsciiZ
                mov     eax, [fscinfo.visual     ]
                call    FBPrintInfo
                mov     eax, fsc07
                call    OutAsciiZ
                xor     eax, eax
                mov     ax, [fscinfo.xpanstep   ]
                call    FBPrintInfo
                mov     eax, fsc08
                call    OutAsciiZ
                xor     eax, eax
                mov     ax, [fscinfo.ypanstep   ]
                call    FBPrintInfo
                mov     eax, fsc09
                call    OutAsciiZ
                xor     eax, eax
                mov     ax, [fscinfo.ywrapstep  ]
                call    FBPrintInfo
                mov     eax, fsc10
                call    OutAsciiZ
                mov     eax, [fscinfo.line_length]
                call    FBPrintInfo
                mov     eax, fsc11
                call    OutAsciiZ
                mov     eax, [fscinfo.mmio_start ]
                call    FBPrintInfo
                mov     eax, fsc12
                call    OutAsciiZ
                mov     eax, [fscinfo.mmio_len   ]
                call    FBPrintInfo
                mov     eax, fsc13
                call    OutAsciiZ
                mov     eax, [fscinfo.accel      ]
                call    FBPrintInfo
                call    NewLine
                ret

FBPrintInfo:
                call    PrintLeft
                call    NewLine
                ret

;==============================================================
section .data

err_msg         db      "fb error!", 10, 0

sc00            db  "Frame Buffer Virtual Screen Information",10,0
sc01            db  " x resolution    : ",0
sc02            db  " y resolution    : ",0
sc03            db  " x res virtual   : ",0
sc04            db  " y res virtual   : ",0
sc05            db  " x offset        : ",0
sc06            db  " y offset        : ",0
sc07            db  " bits/pixel      : ",0
sc08            db  " grayscale       : ",0
sc09            db  " RED    offset   : ",0
sc10            db  "        length   : ",0
sc11            db  "        msb_right: ",0
sc12            db  " GREEN  offset   : ",0
sc13            db  "        length   : ",0
sc14            db  "        msb_right: ",0
sc15            db  " BLUE   offset   : ",0
sc16            db  "        length   : ",0
sc17            db  "        msb_right: ",0
sc18            db  " TRANSP offset   : ",0
sc19            db  "        length   : ",0
sc20            db  "        msb_right: ",0
sc21            db  " nonstd          : ",0
sc22            db  " activate        : ",0
sc23            db  " height          : ",0
sc24            db  " width           : ",0
sc25            db  " accel_flags     : ",0
sc26            db  " pixclock        : ",0
sc27            db  " left margin     : ",0
sc28            db  " right margin    : ",0
sc29            db  " upper margin    : ",0
sc30            db  " lower margin    : ",0
sc31            db  " hsync length    : ",0
sc32            db  " vsync length    : ",0
sc33            db  " sync            : ",0
sc34            db  " vmode           : ",0

fsc00            db  "Frame Buffer Physical Screen Information",10,0
fsc01           db  " ID string               : ",0
fsc02           db  " frame buffer mem start  : $",0
fsc03           db  " frame buffer mem length : ",0
fsc04           db  " frame buffer type       : ",0
fsc05           db  " interleave              : ",0
fsc06           db  " frame buffer visual     : ",0
fsc07           db  " x pan step              : ",0
fsc08           db  " y pan step              : ",0
fsc09           db  " y wrap step             : ",0
fsc10           db  " line length (bytes)     : ",0
fsc11           db  " Memory Mapped I/O start : ",0
fsc12           db  " Memory Mapped I/O length: ",0
fsc13           db  " acceleration type       : ",0

;==============================================================
