;---------------------------------------------------------------------
;   testfpu.asm
;   2000/10/03 Jun Mizutani
;---------------------------------------------------------------------

%include "stdio.inc"
%include "float.inc"

section .bss
fstring         resb 32

section .data
Num100          dt      100.0
TestNum0        db      "000012345678901234567890123.456",0
TestNum1        db      "0000.0000000000012345678901234567890123",0
TestNum2        db      ".123456789012345678E-7",0
cset            db      ' Conversion error!', 0x0A, 0
cclear          db      ' OK!', 0x0A, 0

section .text
global _start

;------------------------------------
; start here
;------------------------------------
_start:
                finit                   ; FPU 
                fldpi                   ; Фpush
                fld    tword [Num100]   ; 100push
                fmulp  st1, st0         ; 100
                call   print_float      ; ɽ
                mov    edi, TestNum0
                call   print_atof       ; ʸưѴɽ
                mov    edi, TestNum1
                call   print_atof       ; ʸưѴɽ
                mov    edi, TestNum2
                call   Exit

;------------------------------------
; ediƬȤʸưѴɽ
print_atof
                mov    eax, edi
                call   OutAsciiZ
                call   Ascii2Float      ; ưʸFPU˥å
                jb     .error
                mov    eax, cclear      ; Ѵ
                jmp    .cend
       .error
                mov    eax, cset        ; Ѵ顼
       .cend
                call   OutAsciiZ
; FPU åȥåפɽ
print_float
                mov    edi, fstring
                call   Float2Ascii
                mov    eax, fstring
                call   OutAsciiZ
                call   NewLine
                call   NewLine
                ret
